HDU - 1024 Max Sum Plus Plus (多段最大连续和+状态压缩)

Max Sum Plus Plus HDU - 1024
Now I think you have got an AC in Ignatius.L’s “Max Sum” problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S 1, S 2, S 3, S 4 … S x, … S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S x ≤ 32767). We define a function sum(i, j) = S i + … + S j (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i 1, j 1) + sum(i 2, j 2) + sum(i 3, j 3) + … + sum(i m, j m) maximal (i x ≤ i y ≤ j x or i x ≤ j y ≤ j x is not allowed).

But I`m lazy, I don’t want to write a special-judge module, so you don’t have to output m pairs of i and j, just output the maximal summation of sum(i x, j x)(1 ≤ x ≤ m) instead. ^_^

Input

Each test case will begin with two integers m and n, followed by n integers S 1, S 2, S 3 … S n.
Process to the end of file.

Output

Output the maximal summation described above in one line.
Sample Input
1 3 1 2 3
2 6 -1 4 -2 3 -2 3
Sample Output
6
8

Hint
Huge input, scanf and dynamic programming is recommended.

题意:有一个n个数的数列,让分成m断,问m段的和最大是多少。

分析:这题有点像多段的最大子串,所以对于第i个数有3种状态。

第一种 拼接到前面
第二种 成为下一个串的开头
第三种 就是不要。
所以我们可以开一个数组 dp[i][j] i代表这是第几段,j代表前j个数
那么3种可以写成
dp[i][j]=max(dp[i][j-1],dp[i-1][j-1])+a[j];
dp[i][j]=max(dp[i][j],dp[i][j-1]);
这里会发现n因为太大所以开不了那么大的数组
于是想到状态压缩,因为我们只需要i和i-1;
所以第一维只需要2就可以了
所以就得到了状态转移方程

AC代码:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
int a[1000100];
int dp[2][1000100];
int sum[1000100];
int main()
{
    int n,m;
    while(scanf("%d%d",&n,&m)==2)
    {
        memset(sum,0,sizeof(sum));
        memset(dp,0,sizeof(dp)); 
        for(int i=1;i<=m;i++)
        {
            scanf("%d",&a[i]);
            sum[i]=sum[i-1]+a[i];
        }
        int count=0;
        for(int i=1;i<=n;i++)
        {
            dp[count][i]=sum[i];
            for(int j=i+1;j<=m;j++)
            {
                dp[count][j]=max(dp[count][j-1],dp[(count+1)%2][j-1])+a[j];
            }
            for(int j=i+1;j<=m;j++)
            {
                dp[count][j]=max(dp[count][j],dp[count][j-1]);
            }
            count=(count+1)%2;
        }
        printf("%d\n",dp[(count+1)%2][m]);
    }
} 
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值